<?php

namespace Litecms\Productt\Policies;

use Litepie\User\Contracts\UserPolicy;
use Litecms\Productt\Models\Productt;

class ProducttPolicy
{

    /**
     * Determine if the given user can view the productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function view(UserPolicy $user, Productt $productt)
    {
        if ($user->canDo('productt.productt.view') && $user->isAdmin()) {
            return true;
        }

        return $productt->user_id == user_id() && $productt->user_type == user_type();
    }

    /**
     * Determine if the given user can create a productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function create(UserPolicy $user)
    {
        return  $user->canDo('productt.productt.create');
    }

    /**
     * Determine if the given user can update the given productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function update(UserPolicy $user, Productt $productt)
    {
        if ($user->canDo('productt.productt.edit') && $user->isAdmin()) {
            return true;
        }

        return $productt->user_id == user_id() && $productt->user_type == user_type();
    }

    /**
     * Determine if the given user can delete the given productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function destroy(UserPolicy $user, Productt $productt)
    {
        return $productt->user_id == user_id() && $productt->user_type == user_type();
    }

    /**
     * Determine if the given user can verify the given productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function verify(UserPolicy $user, Productt $productt)
    {
        if ($user->canDo('productt.productt.verify')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the given user can approve the given productt.
     *
     * @param UserPolicy $user
     * @param Productt $productt
     *
     * @return bool
     */
    public function approve(UserPolicy $user, Productt $productt)
    {
        if ($user->canDo('productt.productt.approve')) {
            return true;
        }

        return false;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperuser()) {
            return true;
        }
    }
}
