<?php

namespace Litecms\Productt\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class ProducttTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Productt\Models\Productt $productt)
    {
        return [
            'id'                => $productt->getRouteKey(),
            'key'               => [
                'public'    => $productt->getPublicKey(),
                'route'     => $productt->getRouteKey(),
            ], 
            'name'              => $productt->name,
            'url'               => [
                'public'    => trans_url('productt/'.$productt->getPublicKey()),
                'user'      => guard_url('productt/productt/'.$productt->getRouteKey()),
            ], 
            'status'            => trans('app.'.$productt->status),
            'created_at'        => format_date($productt->created_at),
            'updated_at'        => format_date($productt->updated_at),
        ];
    }
}